/* #INCLUDE instruction support for EditPlus STX and ACP (CTL) files
 * Author: Welman Jordan (wmjordan#163[dot]com)
 * This script is to revert included contents back to #INCLUDE instruction for further processing
 * Date: 2011-12-15
*/

var CMD = /^#(KEYWORD|T)=/gi;
var FLAG1 = /^;<include file="(.+)">/g;
var FLAG2 = ";</include>";

var STX = 1;
var ACP = 2;

var o = WScript.StdOut;
var c = []; // main content
var st = []; // include stack
var mode = 0;
var bl = 0; // body line

function ParseFile (file, fileName) {
	var inc = false;
	var ln = 0;
	while (!file.AtEndOfStream) {
		var l = file.ReadLine ();
		++ln;
		if (l == FLAG2) {
			inc = false;
			continue;
		}
		var m = FLAG1.exec(l);
		if (m != null) {
			inc = true;
			var n = m[1].toLowerCase();
			for (var i=0; i<st.length; i++) {
				if (st[i] == n) {
					n = null;
					break;
				}
			}
			if (n != null) {
				c.push("#INCLUDE="+m[1]);
				st.push(n);
			}
			continue;
		}
		if (!inc) {
			c.push(l);
		}
		if (mode == 0) {
			m = CMD.exec(l);
			if (m != null) {
				switch (m[1].toUpperCase()) {
				case "KEYWORD": mode = STX; break;
				case "T": mode = ACP; break;
				}
				bl = ln - 1;
			}
		}
	}
}

// main {
	ParseFile (WScript.StdIn);

	if (mode == STX) {
		for (var i=0; i<bl; i++) {
			o.WriteLine (c[i]);
		}
		for (var i=0; i<st.length; i++) {
			o.WriteLine ("#INCLUDE="+st[i]);
		}
		var l = c.length;
		for (var i=bl; i<l; i++) {
			if (c[i].indexOf("#INCLUDE=") == 0) {
				continue;
			}
			o.WriteLine (c[i]);
		}
	}
	else {
		var l = c.length;
		for (var i=0; i<l; i++) {
			o.WriteLine (c[i]);
		}
	}
// }
